SuperStrict
Framework BRL.Blitz
Import BRL.Max2D
Import BRL.PolledInput
Import BRL.Math
Import BRL.Random
Import BRL.LinkedList
Import BRL.GLMax2D

Type TV
	Global ls:TList
	Field x#, y#, xa#, ya#, ox#, oy#, m#
	Field f%
	
	Method New()
		ls.AddLast(Self)
		f = True
	EndMethod
	
	Method Update(t#)
		Local tx#, ty#
		tx = x; ty = y
		x :+ (x - ox + xa * t * t) * f
		y :+ (y - oy + ya * t * t - .06 / m) * f
		If y > 500 Then
			y = 500
			If GameOver = 0 Then FlushKeys()
			GameOver = 1
		EndIf
		ox = tx; oy = ty
		Plot(x, y)
	EndMethod
	
	Method SetPos(sx#, sy#)
		ox = sx - (x - ox); oy = sy - (y - oy)
		x = sx; y = sy
	EndMethod
	
	Function UpdateAll()
		Local t# = (MilliSecs() - lastframe) / 16.0
		For Local v:TV = EachIn ls
			v.Update(t)
		Next
		lastframe = MilliSecs()
	EndFunction
EndType

Type TC
	Global ls:TList
	Field v1:TV, v2:TV
	Field l#
	
	Method New()
		ls.AddLast(Self)
	EndMethod
	
	Method Update()
		Local d# = Pyth(v1.x, v1.y, v2.x, v2.y) - l
		Local nx#, ny#
		Normalize(v1.x, v1.y, v2.x, v2.y, nx, ny)
		v1.x :+ nx*d*0.5 * v1.f
		v1.y :+ ny*d*0.5 * v1.f
		v2.x :- nx*d*0.5 * v2.f
		v2.y :- ny*d*0.5 * v2.f
		Draw()
	EndMethod
	
	Method Draw()
		If v2 = ver[0] Or v2 = ver[1] Or v2 = ver[2] Or v2 = ver[3]
			SetColor(135,135,135)
		ElseIf v1 = ver[6]
			SetColor(150,150,150)
		Else
			SetColor(165,165,165)
		EndIf
		Local w#, d#
		w = (v1.m + v2.m) * 2
		If v1 = ver[6] Then w :* 2
		d = Pyth(v1.x, v1.y, v2.x, v2.y)
		SetHandle(w/2, 0)
		SetRotation(ATan2(v2.y - v1.y,v2.x - v1.x) + 90)
		DrawRect(v2.x, v2.y, w, d)
		SetRotation(0)
		SetHandle(0,0)
	EndMethod
	
	Function UpdateAll()
		For Local c:TC = EachIn ls
			c.Update()
		Next
	EndFunction
EndType
AppTitle="Rapunzel Climber: Still better Physics than Trespassers!"
Graphics 800,600
Global ver:TV[]
Global li:TV[]
Init()

Global lastframe% = MilliSecs()
Global rhx% = 465
Global rhw% = 10
Global avx#, avy#
Global GameOver%
Global Win%

SetClsColor(153,217,234)
While Not KeyHit(KEY_ESCAPE)
	If Not GameOver Or Win Then Ctrl()
	SetCam()
	SetColor(90,90,90)
	DrawRect(600,-3400,300,3900)
	DrawRect(500,-3000,600,100)
	SetColor(255,100,255)
	DrawPoly([rhx + 16.0, -3080.0, Float(rhx), -3000.0, rhx + 32.0, -3000.0])
	'DrawOval(rhx,-3080,32,80)
	SetColor(250,250,100)
	DrawOval(rhx,-3100,32,32)
	DrawRect(rhx,-3080,rhw,3580)
	TV.UpdateAll()
	TC.UpdateAll()
	TC.UpdateAll()
	TC.UpdateAll()
	DrawFig()
	SetOrigin(0, 0)
	SetScale(2,2)
	Local p% = Int(((avy - 400) / -3000) * 100)
	If p > 100 Then Win = True
	SetColor(255, 255, 0)
	DrawText  p + "%", 0, 0
	SetScale(1,1)
	If GameOver Then GO()
	If Win Then Wn()
	Flip 1
	Cls
Wend
Function Ctrl()
	Local fli%
	For Local i% = 0 To 3
		If li[i].x > rhx And li[i].x < rhx + rhw
			li[i].f = False
			fli :+ 1
		EndIf
	Next
	If li[2].f And li[3].f
		li[0].f = 1; li[1].f = 1;
	EndIf
	If fli >= 2
		If KeyDown(KEY_D)
			li[2].y :- 0.7; li[2].f = True
		EndIf
		If KeyDown(KEY_F)
			li[3].y :- 0.7; li[3].f = True
		EndIf
		If KeyDown(KEY_O)
			li[0].y :- 0.25; li[0].f = True
		EndIf
		If KeyDown(KEY_P)
			li[1].y :- 0.25; li[1].f = True
		EndIf
	EndIf
	Local hr# = ATan2(ver[6].y - ver[4].y, ver[6].x - ver[4].x) + 180
	Local br# = ATan2(ver[4].y - ver[5].y, ver[4].x - ver[5].x) + 180
	Local d# = Pyth(ver[6].x, ver[6].y, ver[4].x, ver[4].y)
	If br + 45 < hr Then hr :- (hr - (br + 45)) / 10.0
	If br - 45 > hr Then hr :- (hr - (br - 45)) / 10.0
	ver[6].SetPos(ver[4].x + Cos(hr - 180) * d, ver[4].y + Sin(hr - 180) * d)
EndFunction
Function Wn()
	SetColor(255,200,15)
	Local txt:String = "YOU'VE WON!"
	Local txt2:String = "You've successfully climbed the princess... err... tower!"
	SetScale(4.0, 4.0)
	DrawText(txt, 400 - TextWidth(txt) * 2, 300 - TextHeight(txt) * 2)
	SetScale(1.0, 1.0)
	DrawText(txt2, 400 - TextWidth(txt2) / 2, 380 - TextHeight(txt2) / 2)
EndFunction
Function Init()
	ver = New TV[11]
	TV.ls = New TList
	TC.ls = New TList
	GetFig()
	li = [ver[3], ver[7], ver[0], ver[9]]
EndFunction
Function DrawFig()
	SetColor(0,200,200)
	DrawText("[O]",li[0].x, li[0].y)
	DrawText("[P]",li[1].x, li[1].y)
	DrawText("[D]",li[2].x, li[2].y)
	DrawText("[F]",li[3].x, li[3].y)
EndFunction
Function DrawBG()
	SetColor(0,200,0)
	DrawRect(0,500,800,20)
	SetColor(120,80,60)
	DrawRect(0,520,800,600)
EndFunction
Function GO()
	SetColor(255,0,0)
	Local txt:String = "You fell to your death. :("
	Local txt2:String = "Press R to Restart, ESC to Quit"
	SetScale(3.0, 3.0)
	DrawText(txt, 400 - TextWidth(txt) * 1.5, 300 - TextHeight(txt) * 1.5)
	DrawText(txt2, 400 - TextWidth(txt2) * 1.5, 380 - TextHeight(txt2) * 1.5)
	SetScale(1.0, 1.0)
	
	If KeyHit(KEY_R) Then
		GameOver = False
		Init()
	EndIf
EndFunction
Function SetCam()
	avx = 0; avy = 0
	For Local v:TV = EachIn ver
		avx:+v.x;avy:+v.y
	Next
	avx :/ 11.0
	avy :/ 11.0
	SetOrigin(0, 300 - avy)
	DrawBG()
	SetOrigin(400 - avx, 300 - avy)
EndFunction
Function Normalize(x1#, y1#, x2#, y2#, nx# Var, ny# Var)
	Local dx# = x2 - x1
	Local dy# = y2 - y1
	nx# = dx / (Abs(dx) + Abs(dy))
	ny# = dy / (Abs(dx) + Abs(dy))
EndFunction
Function Pyth#(x1#, y1#, x2#, y2#)
	Return Sqr((x2 - x1)^2 + (y2 - y1)^2)
EndFunction
Function GetFig()
	RestoreData verlets
	For Local i% = 1 To 11
		Local v:TV = New TV
		ReadData v.x, v.y, v.m
		v.ox = v.x; v.oy = v.y
		If i <> 7 Then v.ya = .1
		ver[i - 1] = v
	Next
	RestoreData connections
	For Local i% = 1 To 10
		Local c:TC = New TC
		Local u%, v%
		ReadData u, v
		c.v1 = ver[u]; c.v2 = ver[v]
		c.l = Pyth(c.v1.x, c.v1.y, c.v2.x, c.v2.y)
	Next
EndFunction
#verlets
DefData 310,250,1
DefData 350,250,1.5
DefData 370,330,2
DefData 370,380,1.5
DefData 390,250,5
DefData 390,300,5
DefData 390,220,1.5
DefData 410,380,1.5
DefData 410,330,2
DefData 470,250,1
DefData 430,250,1.5
#connections
DefData 1,0
DefData 4,1
DefData 5,2
DefData 2,3
DefData 5,4
DefData 6,4
DefData 9,10
DefData 10,4
DefData 8,7
DefData 8,5